using CloudBuilder.Core.Authorization;
using CloudBuilder.Core.DatabaseAccessor.Entity;
using System.ComponentModel.DataAnnotations;
using System.ComponentModel.DataAnnotations.Schema;
namespace CloudBuilder.Security.Entity
 {
    [TypeScript]
    [Table("security_permission")]
    public class SecurityPermissionEntity : EntityBase<string>
    {

    public SecurityPermissionEntity() 
    {
    }

    [Column("created_datetime")]
    public DateTime CreatedDatetime  { get; set; }
    [Column("created_by")]
    public string CreatedBy  { get; set; }
    [Column("updated_datetime")]
    public DateTime UpdatedDatetime  { get; set; }
    [Column("updated_by")]
    public string UpdatedBy  { get; set; }
    [Key]
    [Column("permission_name")]
    public string PermissionName  { get; set; }
    [Column("dependent")]
    public string? Dependent  { get; set; }
    [Column("description")]
    public string? Description  { get; set; }
    [Column("delegate_indc")]
    public string DelegateIndc  { get; set; }

    public const string CREATED_DATETIME = "CreatedDatetime";
    public const string CREATED_BY = "CreatedBy";
    public const string UPDATED_DATETIME = "UpdatedDatetime";
    public const string UPDATED_BY = "UpdatedBy";
    public const string PERMISSION_NAME = "PermissionName";
    public const string DEPENDENT = "Dependent";
    public const string DESCRIPTION = "Description";
    public const string DELEGATE_INDC = "DelegateIndc";

    public const string DB_NAME_SECURITY_PERMISSION = "security_permission";
    public const string DB_NAME_FIELDS="created_datetime,created_by,updated_datetime,updated_by,permission_name,dependent,description,delegate_indc";

    public const string DB_CREATED_DATETIME = "created_datetime";
    public const string DB_CREATED_BY = "created_by";
    public const string DB_UPDATED_DATETIME = "updated_datetime";
    public const string DB_UPDATED_BY = "updated_by";
    public const string DB_PERMISSION_NAME = "permission_name";
    public const string DB_DEPENDENT = "dependent";
    public const string DB_DESCRIPTION = "description";
    public const string DB_DELEGATE_INDC = "delegate_indc";


    public static SecurityPermissionEntity GetInstance()
    {
        return new SecurityPermissionEntity();
    }

    public virtual void CopyFrom(SecurityPermissionEntity source)
    {
        CopyFrom(source, true);
    }

    public virtual void CopyFrom(SecurityPermissionEntity source, bool includeSystemFields)
    {
        if (source == null)
        {
            throw new NullReferenceException("Source entity is null.");
        }

        this.CreatedDatetime =  source.CreatedDatetime;
        this.CreatedBy =  source.CreatedBy;
        this.UpdatedDatetime =  source.UpdatedDatetime;
        this.UpdatedBy =  source.UpdatedBy;
        this.PermissionName =  source.PermissionName;
        this.Dependent =  source.Dependent;
        this.Description =  source.Description;
        this.DelegateIndc =  source.DelegateIndc;

        if (includeSystemFields)
        {
        this.CreatedDatetime =  source.CreatedDatetime;
        this.CreatedBy =  source.CreatedBy;
        this.UpdatedDatetime =  source.UpdatedDatetime;
        this.UpdatedBy =  source.UpdatedBy;
        }
    }

    public override string GetSelectFrom()
    {
        return $" select {DB_NAME_FIELDS} from { DB_NAME_SECURITY_PERMISSION}  with(nolock) ";
    }
	
    public override string GetSelectCountFrom(string sqlWhere)
    {
        return $" select count(*) from { DB_NAME_SECURITY_PERMISSION}  with(nolock) where 1=1 {sqlWhere}";
    }
	
    public override string GetSelectTopFrom(int limit, int start,string orderby,string orderbytag,  string sqlWhere)
    {
            if (string.IsNullOrEmpty(orderbytag)  || orderbytag.Trim() != "desc") orderbytag = "asc";
            if (string.IsNullOrEmpty(orderby) || !DB_NAME_FIELDS.Contains(orderby)) orderby =  DB_PERMISSION_NAME ;  		
		string top = limit > 0 ? $"top {limit}" : "";
        return $" select {top} {DB_NAME_FIELDS} from (select {DB_NAME_FIELDS}  ,row_number() over(order by {orderby} {orderbytag}) as num from { DB_NAME_SECURITY_PERMISSION}  with(nolock) where 1=1 {sqlWhere} ) a where num> {limit * (start - 1)}";
    }

    public SecurityPermissionEntity Clone()
    {
        SecurityPermissionEntity result = new SecurityPermissionEntity();
        result.CopyFrom(this);

        return result;
    }

    }
}
